%Program for decoding the LDPC code presented in problem 8.4.
%The channel is a soft decision channel
%It uses the SP algorithm
% Authors: J. Castieira Moreira and P. G. Farrell
% 25/03/2004
% Last update: 15/05/2007
%This program is intended to be for academic proposes, and programming style is not optimised. 
%You can use it to solve problem 8.4 of the book. You can also modify parameters like the 
%H matrix, accordingly N1 and N2, and other parameters to simulate different, 
%in general small, LDPC codes
%this program is paused at different steps to see calculated values
%directly in the Matlab screen, please press any key to advance
%--------------------------------------------------------------------------------------------
clear all;

N1=2; % n-k
N2=5;% n
NUMER_IT=10;

H=zeros(N1,N2);
G=zeros(N2-N1,N2);
t=zeros(1,N2);
c=zeros(1,N2);

H=[1 0 1 0 1
   0 1 0 1 1]; %PC matrix of the code

channel(1,1)=0.5;channel(1,2)=0.3;
channel(1,3)=0.15;channel(1,4)=0.05;
channel(2,1)=0.05;channel(2,2)=0.15;
channel(2,3)=0.3;channel(2,4)=0.5; %soft decision channel, transitions matrix

HT=H';   
S0=zeros(N2-N1,N1);

   
for i=1:N1
onesrow(i)=nnz(H(i,:));
end
for i=1:N2
onescol(i)=nnz(HT(i,:));
end
[row,colum]=find(HT);

count=1;
for i=1:N1
   for j=1:onesrow(i)
   
   check_node(i,j)=row(count);%check_node indicates row indexes of ones 
   count=count+1;   
   end
end

[col,rows]=find(H);
count=1;
for i=1:N2
   for j=1:onescol(i)
   
   symbol_node(i,j)=col(count);%symbol_node indicates column indexes of ones 
   count=count+1;   
   end
end
f0=zeros(1,N2);
f1=zeros(1,N2);

r=[2 1 3 1 1]; %values correspond to the received vector [1 0 2 0 0] +1 to fit Matlab style
r=r';
for t=1:N2
f0(1,t)=channel(1,r(t));
f1(1,t)=channel(2,r(t));%initialization of coefficients f0 and f1
end

stop=0;
iter=0;
   
count=1;
for i=1:N1
   for j=1:onesrow(i)
      Q(i,check_node(i,j),1)=f0(check_node(i,j));
      Q(i,check_node(i,j),2)=f1(check_node(i,j));
   count=count+1;   
   end
end%initialization of coefficients Q0 and Q1

while (iter<=NUMER_IT)&(stop==0) %start of the iterative decoding
  
for i=1:N1
for j=1:onesrow(i)
    addition_factor=zeros(2^onesrow(i),2);
  
   for p=0:2^onesrow(i)-1
      count=0;
      ku=p;
      for s=1:onesrow(i)
         form_bin(s)=bitget(ku,s);
                        
         if form_bin(s)==1
         	count=count+1;
	      end
      end 
            
      c1=1.0;
      for s=1:onesrow(i)
      	if (check_node(i,s)~=check_node(i,j))&(form_bin(j)==0)
         	c1=c1*Q(i,check_node(i,s),form_bin(s)+1);
         	c3=mod(count,2);
            addition_factor(p+1,c3+1)=c1;
         end
      end
     
            
   end
       
   R(i,check_node(i,j),1)=sum(addition_factor(:,1));
   R(i,check_node(i,j),2)=sum(addition_factor(:,2));
   
end
end%calcultation of coefficients R0 and R1
for i=1:N1
      g=zeros(N1,max(onesrow));
      for j=1:onesrow(i)
       b0=1;
       b1=1;
	
        for p1=1:onescol(check_node(i,j))               
             if (check_node(i,j)~=0)&(i~=symbol_node(check_node(i,j),p1))
                b0=b0*R(symbol_node(check_node(i,j),p1),check_node(i,j),1);
             end
          	 if (check_node(i,j)~=0)&(i~=symbol_node(check_node(i,j),p1))
                 b1=b1*R(symbol_node(check_node(i,j),p1),check_node(i,j),2);
             end
      
           
        end
          b0=f0(check_node(i,j))*b0;
          b1=f1(check_node(i,j))*b1;
          
          if(b0==0)&(b1==0)
             Q(i,check_node(i,j),1)=0;
             Q(i,check_node(i,j),2)=0;
          else
             
          g(i,j)=1/(b0+b1);
          Q(i,check_node(i,j),1)=b0*g(i,j);
          Q(i,check_node(i,j),2)=b1*g(i,j);

          
          end
      end
end%calcultation of coefficients Q0 and Q1


R
Q
pause


d0=ones(1,N2);
d1=ones(1,N2);
for j=1:N2
   for i=1:onescol(j);
      d0(j)=d0(j)*R(symbol_node(j,i),j,1);
      d1(j)=d1(j)*R(symbol_node(j,i),j,2);
    
   end
   d0(j)=d0(j)*f0(j);
   d1(j)=d1(j)*f1(j);
end%calcultation of estimates d0 and d1 for the current iteration

bitd=zeros(1,N2);
%save d0.dat d0 /ascii;
%save d1.dat d1 /ascii;
d0
d1
pause

for j=1:N2
   if d0(j)>d1(j)
      bitd(1,j)=0;
   else
      bitd(1,j)=1;
   end
end

bitd %estimated vector
pause

Sc=zeros(1,N1);
Sc=mod(bitd*HT,2);
Sindro=sum(Sc);   %calculation of the syndrome


if (Sindro==0)         
   stop=1;
end
iter
output=bitd(1,N1+1:N2);%decoded message vector
iter=iter+1;

end       









   